/*
 *  cubesql_plugin.c
 *
 *  Created by Marco Bambini on 1/5/08.
 *  Copyright 2005-2011 SQLabs. All rights reserved.
 * 
 *  DO NOT EDIT THIS FILE!
 */

#include "cubesql_plugin.h"

static PluginResolver *gresolver;

#pragma mark -

int cubesql_plugin_main (PluginResolver *resolver)
{	
	gresolver = resolver;
	return CUBESQL_API_VESION;
}

//  main functions (5)
int cubesql_register_sql_function  (void *pluginref, const char *name, int num_args, int text_encoding, void *user_data, void (*xFunc)(cubesql_context *ctx, int argc, cubesql_value **argv))
{
	return gresolver->csql_register_sql_function (pluginref, name, num_args, text_encoding, user_data, xFunc);
}

int cubesql_register_sql_aggregate (void *pluginref, const char *name, int num_args, int text_encoding, void *user_data, void (*xStep)(cubesql_context *ctx, int argc, cubesql_value **argv), void (*xFinal)(cubesql_context *ctx))
{
	return gresolver->csql_register_sql_aggregate (pluginref, name, num_args, text_encoding, user_data, xStep, xFinal);
}

int cubesql_register_sql_collation (void *pluginref, const char *name, int text_encoding, void *user_data, int(*xCompare)(void *user_data, int len1, const void *str1, int len2, const void *str2), void(*xDestroy)(void *user_data))
{
	return gresolver->csql_register_sql_collation (pluginref, name, text_encoding, user_data, xCompare, xDestroy);
}

int cubesql_register_command (void *pluginref, const char *command, int invisible, int dbref_required, int context, int commandID, int privilegeCode, int (*xCommand)(cubesql_client *client, const char **args, int commandID))
{
	return gresolver->csql_register_command (pluginref, command, invisible, dbref_required, context, commandID, privilegeCode, xCommand);
}

int cubesql_register_protocol (void *pluginref, int command, int bitfield, int (*xProtocol)(cubesql_client *client))
{
	return gresolver->csql_register_protocol (pluginref, command, bitfield, xProtocol);
}

#pragma mark -

// utils (16)
int cubesql_file_copy (char *dest, char *src)
{
	return gresolver->csql_file_copy (dest, src);
}

int cubesql_file_delete (char *path)
{
	return gresolver->csql_file_delete (path);
}

int cubesql_file_exists (const char *path)
{
	return gresolver->csql_file_exists (path);
}

int cubesql_file_rename (const char *oldname, const char *newname)
{
	return gresolver->csql_file_rename (oldname, newname);
}

int cubesql_file_write (char *file_path, char *buffer, int len)
{
	return gresolver->csql_file_write (file_path, buffer, len);
}

int cubesql_path_is_directory (char *path)
{
	return gresolver->csql_path_is_directory (path);
}

void cubesql_path_build (char *path, char *path1, const char *path2)
{
	gresolver->csql_path_build (path, path1, path2);
}

int cubesql_directory_create (char *path)
{
	return gresolver->csql_directory_create (path);
}

DIRREF cubesql_dir_init (char *dirpath)
{
	return gresolver->csql_dir_init (dirpath);
}

char* cubesql_dir_read (DIRREF dref)
{
	return gresolver->csql_dir_read (dref);
}

void cubesql_log (char *msg)
{
	gresolver->csql_log(msg);
}

int cubesql_num_processors (void)
{
	return gresolver->csql_num_processors();
}

char* cubesql_ip_address (void)
{
	return gresolver->csql_ip_address ();
}

char* cubesql_os_version (char *buf, int len)
{
	return gresolver->csql_os_version (buf, len);
}

char* cubesql_compress_buffer (char *buffer1, int buffer1Size, char *buffer2, int buffer2Size, int *compressedSize)
{
	return gresolver->csql_compress_buffer (buffer1, buffer1Size, buffer2, buffer2Size, compressedSize);
}

void cubesql_client_set_error (cubesql_client *client, int errcode, char *errmsg)
{
	gresolver->csql_client_set_error(client, errcode, errmsg);
}

#pragma mark -

// preferences (3)
char* cubesql_pref_read (char *key, char *domain, char *buffer, int blen)
{
	return gresolver->csql_pref_read(key, domain, buffer, blen);
}

int cubesql_pref_write (char *key, char *value, char *domain)
{
	return gresolver->csql_pref_write(key, value, domain);
}

int cubesql_pref_delete (char *key, char *domain)
{
	return gresolver->csql_pref_delete(key, domain);
}

#pragma mark -

// db (10)
cubesql_db* cubesql_db_create_inmemory (void)
{
	return gresolver->csql_db_create_inmemory();
}

cubesql_db* cubesql_db_open (char *name, char *key, int *flag)
{
	return gresolver->csql_db_open (name, key, flag);
}

void cubesql_db_close (cubesql_db *db)
{
	gresolver->csql_db_close (db);
}

int cubesql_db_write (cubesql_db *db, char *sql)
{
	return gresolver->csql_db_write (db, sql);
}

int cubesql_db_read_table (cubesql_db *db, char *sql, char ***result, int *nrows, int *ncolumns)
{
	return gresolver->csql_db_read_table (db, sql, result, nrows, ncolumns);
}

void cubesql_db_free_table (char **result)
{
	gresolver->csql_db_free_table (result);
}

char* cubesql_db_column_read (cubesql_db *db, char *sql, int colnum, char *buffer, int blen)
{
	return gresolver->csql_db_column_read (db, sql, colnum, buffer, blen);
}

void cubesql_db_send_cursor (cubesql_db *db, char *sql, cubesql_client *client)
{
	gresolver->csql_db_send_cursor(db, sql, client);
}

int cubesql_db_errcode (cubesql_db *db)
{
	return gresolver->csql_db_errcode (db);
}

char* cubesql_db_errmsg (cubesql_db *db)
{
	return gresolver->csql_db_errmsg (db);
}

#pragma mark -

// string (9)
int cubesql_strcmpi (const char *s1, const char *s2)
{
	return gresolver->csql_strcmpi (s1, s2);
}

int cubesql_strncmpi (const char *s1, const char *s2, int i)
{
	return gresolver->csql_strncmpi (s1, s2, i);
}

char* cubesql_strdup (const char *s)
{
	return gresolver->csql_strdup (s);
}

char* cubesql_strndup (const char *s, size_t n)
{
	return gresolver->csql_strndup (s, n);
}

char* cubesql_strtrim (char *s)
{
	return gresolver->csql_strtrim (s);
}

int cubesql_strncasecmp (const char *s1, const char *s2, size_t n)
{
	return gresolver->csql_strncasecmp (s1, s2, n);
}

char* cubesql_strcasestr (const char *s, const char *find)
{
	return gresolver->csql_strcasestr (s, find);
}

char* cubesql_strlowercase (char *s)
{
	return gresolver->csql_strlowercase (s);
}

char* cubesql_struppercase (char *s)
{
	return gresolver->csql_struppercase (s);
}

#pragma mark -

// sqlite (32)
void *cubesql_user_data (cubesql_context *ctx)
{
	return gresolver->csql_user_data (ctx);
}

void *cubesql_aggregate_context (cubesql_context* ctx, int nbytes)
{
	return gresolver->csql_aggregate_context (ctx, nbytes);
}

void *cubesql_malloc (int dim)
{
	return gresolver->csql_malloc(dim);
}

void *cubesql_realloc (void *p, int nbytes)
{
	return gresolver->csql_realloc (p, nbytes);
}

void cubesql_free (void *p)
{
	gresolver->csql_free(p);
}

const void *cubesql_value_blob (cubesql_value *param)
{
	return gresolver->csql_value_blob(param);
}

int cubesql_value_bytes (cubesql_value *param)
{
	return gresolver->csql_value_bytes(param);
}

int cubesql_value_bytes16 (cubesql_value *param)
{
	return gresolver->csql_value_bytes16(param);
}

double cubesql_value_double (cubesql_value *param)
{
	return gresolver->csql_value_double(param);
}

int cubesql_value_int (cubesql_value *param)
{
	return gresolver->csql_value_int(param);
}

cubesql_int64 cubesql_value_int64 (cubesql_value *param)
{
	return gresolver->csql_value_int64(param);
}

const unsigned char *cubesql_value_text (cubesql_value *param)
{
	return gresolver->csql_value_text(param);
}

const void *cubesql_value_text16 (cubesql_value *param)
{
	return gresolver->csql_value_text16(param);
}

const void *cubesql_value_text16le (cubesql_value *param)
{
	return gresolver->csql_value_text16le(param);
}

const void *cubesql_value_text16be (cubesql_value *param)
{
	return gresolver->csql_value_text16be(param);
}

int cubesql_value_type (cubesql_value *param)
{
	return gresolver->csql_value_type(param);
}

int cubesql_value_numeric_type (cubesql_value *param)
{
	return gresolver->csql_value_numeric_type(param);
}

void cubesql_result_blob (cubesql_context* ctx, const void *data, int len, void(*p)(void*))
{
	gresolver->csql_result_blob(ctx, data, len, p);
}

void cubesql_result_double (cubesql_context* ctx, double value)
{
	gresolver->csql_result_double(ctx, value);
}

void cubesql_result_error (cubesql_context* ctx, const char *s, int len)
{
	gresolver->csql_result_error(ctx, s, len);
}

void cubesql_result_error16 (cubesql_context* ctx, const void *s, int len)
{
	gresolver->csql_result_error16 (ctx, s, len);
}

void cubesql_result_error_toobig (cubesql_context* ctx)
{
	gresolver->csql_result_error_toobig(ctx);
}

void cubesql_result_error_nomem (cubesql_context* ctx)
{
	gresolver->csql_result_error_nomem(ctx);
}

void cubesql_result_int (cubesql_context* ctx, int value)
{
	gresolver->csql_result_int(ctx, value);
}

void cubesql_result_int64 (cubesql_context* ctx, cubesql_int64 value)
{
	gresolver->csql_result_int64(ctx, value);
}

void cubesql_result_null (cubesql_context* ctx)
{
	gresolver->csql_result_null(ctx);
}

void cubesql_result_text (cubesql_context* ctx, const char *s, int len, void(*p)(void*))
{
	gresolver->csql_result_text(ctx, s, len, p);
}

void cubesql_result_text16 (cubesql_context* ctx, const void *s, int len, void(*p)(void*))
{
	gresolver->csql_result_text16(ctx, s, len, p);
}

void cubesql_result_text16le (cubesql_context* ctx, const void *s, int len, void(*p)(void*))
{
	gresolver->csql_result_text16le(ctx, s, len, p);
}

void cubesql_result_text16be (cubesql_context* ctx, const void *s, int len, void(*p)(void*))
{
	gresolver->csql_result_text16be(ctx, s, len, p);
}

void cubesql_result_value (cubesql_context* ctx, cubesql_value *param)
{
	gresolver->csql_result_value (ctx, param);
}

void cubesql_result_zeroblob (cubesql_context* ctx, int n)
{
	gresolver->csql_result_zeroblob (ctx, n);
}

#pragma mark -

int cubesql_client_userid (void)
{
	return gresolver->csql_client_userid();
}

char* cubesql_client_groupid (void)
{
	return gresolver->csql_client_groupid();
}

char* cubesql_client_username (void)
{
	return gresolver->csql_client_username();
}

char* cubesql_client_groupname (int groupid)
{
	return gresolver->csql_client_groupname(groupid);
}

char* cubesql_client_ip_address (void)
{
	return gresolver->csql_client_ip_address();
}

